## vlc-plugin-bittorrent 2.16

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(
  "vlc-plugin-bittorrent"
  VERSION 2.16
  DESCRIPTION "A bittorrent plugin for VLC."
  HOMEPAGE_URL "https://github.com/johang/vlc-bittorrent"
  LANGUAGES C CXX
)

add_subdirectory(src)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(vlc-bittorrent)

find_package(PkgConfig REQUIRED)
find_package(Threads REQUIRED)

pkg_check_modules(
  VlcPlugin
    REQUIRED IMPORTED_TARGET
      "vlc-plugin >= 3.0.0"
)

pkg_check_modules(
  LibtorrentRasterbar
    REQUIRED IMPORTED_TARGET
      "libtorrent-rasterbar >= 2.0.0"
)

add_library(
  access_bittorrent_plugin
    MODULE
      module.cpp
      metadata.cpp
      magnetmetadata.cpp
      data.cpp
      download.cpp
      session.cpp
      vlc.cpp
)

target_include_directories(
  access_bittorrent_plugin
    PRIVATE
      ${CMAKE_BINARY_DIR}
)

target_compile_definitions(
  access_bittorrent_plugin
    PRIVATE
      -DMODULE_STRING=\"bittorrent\"
      -D__PLUGIN__
      -DPACKAGE=\"vlc-bittorrent\"
)

target_compile_features(
  access_bittorrent_plugin
    PUBLIC
      cxx_std_14
)

target_link_libraries(
  access_bittorrent_plugin
    PUBLIC
      PkgConfig::VlcPlugin
      PkgConfig::LibtorrentRasterbar
)

set_target_properties(
  access_bittorrent_plugin
    PROPERTIES
      CXX_STANDARD 14
      CXX_STANDARD_REQUIRED YES
      CXX_VISIBILITY_PRESET hidden
)

## vlc-plugin-bittorrent 2.3

=== debian/changelog ===
vlc-plugin-bittorrent (2.3-4~mx17+1) mx; urgency=medium

  * Repackaged for MX 17 & 18.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Tue, 11 Dec 2018 13:42:24 -0800

vlc-plugin-bittorrent (2.3-4) unstable; urgency=medium

  * Rewrote autopkgtest script to be more robust and not output to
    stderr.
  * Renamed 1020-desktop-not-in-menu.patch to
    0000-desktop-not-in-menu.patch after it was applied upstream.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 23 Oct 2018 08:02:13 +0200

vlc-plugin-bittorrent (2.3-3) unstable; urgency=medium

  * Removed d/vlc-plugin-bittorrent.mime as the desktop file is enough
    according to policy 9.7.2.
  * Add required vlc dependency to autopkgtest control file.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 22 Oct 2018 21:41:50 +0200

vlc-plugin-bittorrent (2.3-2) unstable; urgency=medium

  * Add simple autopkgtest check.
  * Added 1020-desktop-not-in-menu.patch to avoid several VLC menu
    entries.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 21 Oct 2018 12:14:26 +0200

vlc-plugin-bittorrent (2.3-1) unstable; urgency=medium

  * New upstream version 2.3
  * Removed .desktop file from debian/, now included upstream.
  * Renamed patch files to indicate they might be upstream material.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 21 Oct 2018 08:18:41 +0200

vlc-plugin-bittorrent (2.2-4) unstable; urgency=medium

  * Document strict build dependency, require vlc >= 3~.
  * Updated d/control to state plugin package enhance vlc.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 15 Oct 2018 19:25:17 +0200

vlc-plugin-bittorrent (2.2-3) unstable; urgency=medium

  * Added desktop file suggesting vlc for application/x-bittorrent and
    x-scheme-handler/magnet mime types.
  * Extended mime entry with x-scheme-handler/magnet.
  * Added 2010-remove-on-exit.patch to remove temporary files when
    exiting vlc.
  * Adjusted mime setup for starting vlc to work the same way as the
    desktop file.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 14 Oct 2018 20:36:40 +0200

vlc-plugin-bittorrent (2.2-2) unstable; urgency=medium

  * Added new libvlc-dev build dependency, possibly needed during
    build testing.
  * Added mime handler suggesting vlc for .torrent files.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 09 Oct 2018 07:59:56 +0200

vlc-plugin-bittorrent (2.2-1) unstable; urgency=medium

  * New upstream version 2.2.
  * Marked binary package vlc-plugin-bittorrent Multi-Arch same.
  * Added 2000-size-sorted-files.patch to make sure torrent playlist
    ordering is stable and predictable.
  * Changed d/rules to allow dh_auto_test to fail until we figure out
    how to fix it.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 08 Oct 2018 19:18:30 +0200

vlc-plugin-bittorrent (2.1-1) unstable; urgency=medium

  * New upstream version 2.1
    - Removed all patches, now applied upstream.
  * Added Vcs links to d/control.
  * Added d/gbp.conf to enforce the use of pristine-tar.
  * Corrected upstream links, git repo links and d/rules file.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 24 Sep 2018 21:28:40 +0200

vlc-plugin-bittorrent (2.0-1) unstable; urgency=medium

  * Initial release (Closes: #890360).

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 18 Sep 2018 19:49:54 +0000

=== debian/control ===
Source: vlc-plugin-bittorrent
Priority: optional
Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
XSBC-Original-Maintainer: Petter Reinholdtsen <pere@debian.org>
Build-Depends: debhelper (>= 10~),
               libtorrent-rasterbar-dev,
               libvlc-dev (>= 3~),
               libvlccore-dev (>= 3~),
Standards-Version: 4.2.1
Section: video
Homepage: https://github.com/johang/vlc-bittorrent
Vcs-Git: https://salsa.debian.org/pere/vlc-plugin-bittorrent.git
Vcs-Browser: https://salsa.debian.org/pere/vlc-plugin-bittorrent

Package: vlc-plugin-bittorrent
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: vlc
Description: Bittorrent plugin for VLC
 VLC is the VideoLAN project's media player.
 .
 This plugin adds support streaming content using bittorrent, either by
 specifying a torrent file, or by providing a magnet link.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/architecture.mk
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- --libdir=/usr/lib/$(DEB_TARGET_MULTIARCH)/vlc/plugins

override_dh_auto_install:
	dh_auto_install
	find debian/vlc-plugin-bittorrent/ -name '*.la' -delete
	find debian/vlc-plugin-bittorrent/ -name '*.a' -delete
override_dh_auto_test:
	-dh_auto_test

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## vlc-plugin-bittorrent 2.6

=== debian/changelog ===
vlc-plugin-bittorrent (2.6-1) unstable; urgency=medium

  * New upstream version 2.6
  * Dropped 0000-priority.patch included in new upstream version.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 17 Jan 2019 13:29:35 +0100

vlc-plugin-bittorrent (2.5-2) unstable; urgency=medium

  * Updated Standards-Version from 4.2.1 to 4.3.0.
  * Fetched 0000-priority.patch from upstream to adjust download
    priority.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 25 Dec 2018 13:03:10 +0100

vlc-plugin-bittorrent (2.5-1) unstable; urgency=medium

  * New upstream version 2.5.
    - Reduced torrent buffering and timeouts to improve playback.
    - Improved crash handling
    - Improved self testing to ensure plugin is working.
  * Adjusted d/rules to remove d/files in clean target.
  * Ignore the desktop-command-not-in-package lintian warning, as this
    is intentional.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 20 Dec 2018 11:25:09 +0000

vlc-plugin-bittorrent (2.4-1) unstable; urgency=medium

  * New upstream version 2.4.
     - No longer block VLC at the start.
     - Try to avoid playing non-media files.
  * Added Rules-Requires-Root: no in d/control to document build
    requirements.
  * Removed 0000-desktop-not-in-menu.patch now applied upstream.
  * Disabled 1000-size-sorted-files.patch and
    1010-remove-on-exit.patch.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 11 Dec 2018 21:07:08 +0000

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,16 @@
 Source: vlc-plugin-bittorrent
 Priority: optional
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
-XSBC-Original-Maintainer: Petter Reinholdtsen <pere@debian.org>
+Maintainer: Petter Reinholdtsen <pere@debian.org>
 Build-Depends: debhelper (>= 10~),
                libtorrent-rasterbar-dev,
                libvlc-dev (>= 3~),
                libvlccore-dev (>= 3~),
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Section: video
 Homepage: https://github.com/johang/vlc-bittorrent
 Vcs-Git: https://salsa.debian.org/pere/vlc-plugin-bittorrent.git
 Vcs-Browser: https://salsa.debian.org/pere/vlc-plugin-bittorrent
+Rules-Requires-Root: no
 
 Package: vlc-plugin-bittorrent
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -31,6 +31,6 @@
 override_dh_auto_test:
 	-dh_auto_test
 
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
-	
+override_dh_auto_clean:
+	dh_auto_clean
+	$(RM) debian/files

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/vlc-plugin-bittorrent-$1.tar.gz/ \
https://github.com/johang/vlc-bittorrent/releases \
.*/archive/v?([\d\.]+).tar.gz

## vlc-plugin-bittorrent 2.11

=== debian/changelog ===
vlc-plugin-bittorrent (2.11-1) unstable; urgency=medium

  * New upstream version 2.11.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 04 Jul 2020 17:10:53 +0200

vlc-plugin-bittorrent (2.10-2) unstable; urgency=medium

  * Set $HOME to an existing and writable location when running tests,
    to keep libvlc happy.  Could get more tests working during build.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 16 Jun 2020 11:50:48 +0200

vlc-plugin-bittorrent (2.10-1) unstable; urgency=medium

  * New upstream version 2.10.
    - Fixes SEGFAULT on exit (Closes: #961483).

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 14 Jun 2020 15:13:53 +0200

vlc-plugin-bittorrent (2.9-1) unstable; urgency=medium

  * New upstream version 2.9.
  * Updated Standards-Version from 4.3.0 to 4.5.0.
  * Adjusted build rules to use new --with-tests configure flag.
  * Replaced ADTTMP with AUTOPKGTEST_TMP. Thank you, lintian.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 24 May 2020 13:48:00 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,11 @@
 Priority: optional
 Maintainer: Petter Reinholdtsen <pere@debian.org>
 Build-Depends: debhelper (>= 10~),
+               autoconf-archive,
                libtorrent-rasterbar-dev,
                libvlc-dev (>= 3~),
                libvlccore-dev (>= 3~),
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Section: video
 Homepage: https://github.com/johang/vlc-bittorrent
 Vcs-Git: https://salsa.debian.org/pere/vlc-plugin-bittorrent.git

## vlc-plugin-bittorrent 2.12

=== debian/changelog ===
vlc-plugin-bittorrent (2.12-2) unstable; urgency=medium

  * Upload to unstable.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 08 Jan 2021 20:15:09 +0100

vlc-plugin-bittorrent (2.12-1) experimental; urgency=medium

  * New upstream version 2.12.
    - Rewritten to use the stream_extractor API, adding support
      for libtorrent 2.0.
  * Updated Standards-Version from 4.5.0 to 4.5.1.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 28 Dec 2020 06:53:05 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libtorrent-rasterbar-dev,
                libvlc-dev (>= 3~),
                libvlccore-dev (>= 3~),
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Section: video
 Homepage: https://github.com/johang/vlc-bittorrent
 Vcs-Git: https://salsa.debian.org/pere/vlc-plugin-bittorrent.git

=== debian/rules ===
--- 
+++ 
@@ -22,14 +22,18 @@
 
 
 override_dh_auto_configure:
-	dh_auto_configure -- --libdir=/usr/lib/$(DEB_TARGET_MULTIARCH)/vlc/plugins
+	dh_auto_configure -- --libdir=/usr/lib/$(DEB_TARGET_MULTIARCH)/vlc/plugins --with-tests
 
 override_dh_auto_install:
 	dh_auto_install
 	find debian/vlc-plugin-bittorrent/ -name '*.la' -delete
 	find debian/vlc-plugin-bittorrent/ -name '*.a' -delete
 override_dh_auto_test:
-	-dh_auto_test
+	# The VLC test need to write to $HOME, make sure $HOME exist and is writable.
+	# Could use debhelper compat level 13 to get the same effect, but stable
+	# currently have level 12 and I want it to be buildable in stable without
+	# a backported debhelper.
+	-HOME=$(CURDIR)/debian/tmp dh_auto_test
 
 override_dh_auto_clean:
 	dh_auto_clean

## vlc-plugin-bittorrent 2.14

=== debian/changelog ===
vlc-plugin-bittorrent (2.14-1) unstable; urgency=medium

  * New upstream version 2.14
  * Updated d/watch list to work with upstream scheme.
  * Updated years in d/copyright files.
  * Updated d/watch file to version 4.
  * Switched to debhelper-compat style level setting.
  * Adjusted d/rules to clean out generated test/data/vlcdummy-vlc.log.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 14 Feb 2022 07:44:04 +0100

vlc-plugin-bittorrent (2.13-1) unstable; urgency=medium

  * New upstream version 2.13
  * Replaced d/watch file with one that work.
  * Updated Standards-Version from 4.5.1 to 4.6.0
  * Updated dh compat level from 10 to 13.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 14 Sep 2021 16:57:05 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: vlc-plugin-bittorrent
 Priority: optional
 Maintainer: Petter Reinholdtsen <pere@debian.org>
-Build-Depends: debhelper (>= 10~),
+Build-Depends: debhelper-compat (= 13),
                autoconf-archive,
                libtorrent-rasterbar-dev,
                libvlc-dev (>= 3~),
                libvlccore-dev (>= 3~),
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Section: video
 Homepage: https://github.com/johang/vlc-bittorrent
 Vcs-Git: https://salsa.debian.org/pere/vlc-plugin-bittorrent.git

=== debian/rules ===
--- 
+++ 
@@ -37,4 +37,4 @@
 
 override_dh_auto_clean:
 	dh_auto_clean
-	$(RM) debian/files
+	$(RM) debian/files test/data/vlcdummy-vlc.log

## vlc-plugin-bittorrent 2.15

=== debian/changelog ===
vlc-plugin-bittorrent (2.15-2) unstable; urgency=medium

  * Added d/upstream/metadata.
  * Set upstream metadata fields: Repository.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 14 Aug 2024 23:00:04 +0200

vlc-plugin-bittorrent (2.15-1) unstable; urgency=medium

  * New upstream version 2.15
  * Corrected d/rules comment on $HOME setting.
  * Added VLC plugin API package relation to ensure VLC compatibility.
    (Closes: #1060138)

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 12 Jan 2024 08:34:49 +0100

vlc-plugin-bittorrent (2.14-4) unstable; urgency=medium

  * Revert earlier change to let debhelper set HOME, as it seem to
    not work.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 26 Dec 2023 11:55:20 +0100

vlc-plugin-bittorrent (2.14-3) unstable; urgency=medium

  * Removed override for dh_auto_test as debhelper level 13 now set HOME.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 25 Dec 2023 18:48:42 +0100

vlc-plugin-bittorrent (2.14-2) unstable; urgency=medium

  * Updated Standards-Version from 4.6.0 to 4.6.2.
  * Moved package git depot to debian salsa group to make shared
    maintenance easier.
  * Corrected lintian override about unusual desktop content.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 20 Dec 2023 08:50:57 +0100

=== debian/control ===
--- 
+++ 
@@ -6,17 +6,17 @@
                libtorrent-rasterbar-dev,
                libvlc-dev (>= 3~),
                libvlccore-dev (>= 3~),
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Section: video
 Homepage: https://github.com/johang/vlc-bittorrent
-Vcs-Git: https://salsa.debian.org/pere/vlc-plugin-bittorrent.git
-Vcs-Browser: https://salsa.debian.org/pere/vlc-plugin-bittorrent
+Vcs-Git: https://salsa.debian.org/debian/vlc-plugin-bittorrent.git
+Vcs-Browser: https://salsa.debian.org/debian/vlc-plugin-bittorrent
 Rules-Requires-Root: no
 
 Package: vlc-plugin-bittorrent
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${vlc:PluginABI}
 Enhances: vlc
 Description: Bittorrent plugin for VLC
  VLC is the VideoLAN project's media player.

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,6 @@
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 include /usr/share/dpkg/architecture.mk
-export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 %:
@@ -29,11 +28,16 @@
 	find debian/vlc-plugin-bittorrent/ -name '*.la' -delete
 	find debian/vlc-plugin-bittorrent/ -name '*.a' -delete
 override_dh_auto_test:
-	# The VLC test need to write to $HOME, make sure $HOME exist and is writable.
-	# Could use debhelper compat level 13 to get the same effect, but stable
-	# currently have level 12 and I want it to be buildable in stable without
-	# a backported debhelper.
+	# The VLC test need to write to $HOME, make sure $HOME exist
+	# and is writable.  Tried useing debhelper compat level 13 to
+	# get the same effect, but it did not work.
 	-HOME=$(CURDIR)/debian/tmp dh_auto_test
+
+# Provide substvar with VLC plugin ABI reference (BTS #1060138)
+override_dh_gencontrol-arch:
+	sed -n 's/^# define MODULE_SYMBOL \([0-9][_0-9a-z]*\)/-Vvlc:PluginABI=vlc-plugin-abi-\1/p' \
+	  /usr/include/vlc/plugins/vlc_plugin.h | \
+	  tr _ - | xargs dh_gencontrol -a --
 
 override_dh_auto_clean:
 	dh_auto_clean

=== debian/tests/control ===
Depends: @, vlc, valgrind
Tests: test-vlc

## vlc-plugin-bittorrent 2.16

=== debian/changelog ===
vlc-plugin-bittorrent (2.16-1) unstable; urgency=medium

  * New upstream version 2.16
  * Adjusted lintian-overrides for new edition.
  * Updated Standards-Version from 4.6.2 to 4.7.3.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 03 Jan 2026 23:02:34 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libtorrent-rasterbar-dev,
                libvlc-dev (>= 3~),
                libvlccore-dev (>= 3~),
-Standards-Version: 4.6.2
+Standards-Version: 4.7.3
 Section: video
 Homepage: https://github.com/johang/vlc-bittorrent
 Vcs-Git: https://salsa.debian.org/debian/vlc-plugin-bittorrent.git
